# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define section free
%define saajver 1.3

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           sun-saaj-1.3-impl
Version:        1.3.16
Release:        7%{?reltag}%{?dist}
Epoch:          0
Summary:        SAAJ 1.3 RI
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://saaj.dev.java.net/
%if 0
svn -q export -r 391 https://svn.java.net/svn/saaj~svn/tags/saaj-impl-1.3.16 && tar czf saaj-impl-1.3.16.tar.gz saaj-impl-1.3.16
%endif
Source0:        saaj-impl-1.3.16.tar.gz
Source1:        CDDLv1.0.html
%if 0
git clone git://github.com/asoldano/saaj-impl.git
git checkout 1.3.16-jbossorg-1
HEAD is now at 5b3b597... Fix typo in version
rm -rf .git*
cd ..
mv saaj-impl saaj-impl.org
tar zxf saaj-impl-1.3.16.tar.gz
diff -uNr saaj-impl-1.3.16 saaj-impl.jbossorg > saaj-impl-1.3.16-jbossorg.patch
%endif
Patch0:         saaj-impl-1.3.16-jbossorg.patch
Patch1:         sun-saaj-1.3-impl-pom-vman.patch
Patch2:         sun-saaj-1.3-impl-build.patch
#Patch3:         sun-saaj-1.3-impl-saaj.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       xerces-j2
BuildRequires:  jboss-parent
BuildRequires:  jvnet-parent
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  maven2 >= 2.0.7
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  sun-mimepull
BuildRequires:  xerces-j2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The SOAP with Attachments API for Java (SAAJ) 1.3
Reference Implementation.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if 0
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep 
%setup -q -n saaj-impl-1.3.16
find -type f \( -name "*.jar" -o -name "*.zip" \) | xargs -t rm
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
#%patch3 -p1 -b .sav3

cp -p %{SOURCE1} .

%build

export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e -X -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.failure.ignore deploy javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p target/saaj-impl-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
cp -p target/saaj-impl-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar

(cd %{buildroot}%{_javadir} && ln -s %{name}-%{namedversion}.jar %{name}.jar)
(cd %{buildroot}%{_javadir} && ln -s %{name}-%{namedversion}-sources.jar %{name}-sources.jar)

# poms
mkdir -p %{buildroot}%{_mavenpomdir}
cp -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_to_maven_depmap com.sun.xml.messaging.saaj saaj-impl %{namedversion} JPP %{name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if 0
mkdir -p %{buildroot}%{_docdir}/%{name}-%{namedversion}
cp -pr docs/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%endif

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CDDLv1.0.html
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}-sources.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if 0
%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{namedversion}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu May 10 2012 Yong Yang <yyang@redhat.com> - 0:1.3.16-7.redhat_1
- Build against jb-eap-6-rhel-6

* Mon Apr 16 2012 Yong Yang <yyang@redhat.com> - 0:1.3.16-6.redhat_1
- Use mvn-jpp to build to fix JBPAPP-8391

* Thu Apr 12 2012 Yong Yang <yyang@redhat.com> - 0:1.3.16-5_redhat_1.3
- Correct release

* Thu Apr 12 2012 Yong Yang <yyang@redhat.com> - 0:1.3.16-5_redhat_1.2
- Integrate Patch3 "set mimepull as provided (not needed unless saaj.use.mimepull=true)" to vman patch
- Keep the version for mimepull in pom.xml, otherwise will cause maven fail to resolve version, because its scope is "provided" now, this transitive dependency will not be downloaded and used for compile by maven

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.3.16-5_redhat_1.1
- Rebuild using cache signing

* Tue Feb 07 2012 David Walluck <dwalluck@redhat.com> 0:1.3.16-5
- remove Requires: sun-mimepull
- set mimepull as provided (not needed unless saaj.use.mimepull=true)
- fix Release

- add (Build)Requires: xerces-j2 (added by jbossorg patch)
- remove Requires: jaf_1_1_api (included in rt.jar)
- remove Requires: qname_1_1_api (included in rt.jar)
- remove (Build)Requires: saaj_1_3_api
- remove included jar and zip files
- fix bad pom name
- fix doc
- fix repolib deploy
- fix repolib file ownership
- remove GCJ support

* Tue Nov 22 2011 Yong Yang <yyang@redhat.com> - 0:1.3.16-3_redhat_1
- Fix version in pom

* Tue Nov 22 2011 Yong Yang <yyang@redhat.com> - 0:1.3.16-2_redhat_1
- Create Source0 from the orignal source repo, and apply jbossorg changes by patch
- Fix reltag, change from _jbossorg_1 to _redhat_1

* Mon Nov 21 2011 Yong Yang <yyang@redhat.com> - 0:1.3.16-1_jbossorg_1
- Upgrade to 1.3.16-jbossorg-1
- (B)R sun-mimepull

* Thu Jun 16 2011 Yong Yang <yyang@redhat.com> - 0:1.3.2-2.2
- Deploy jar to maven2-brew of repolib

* Tue Jan 19 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.3.2-2.1
- Disable aot compiler 

* Tue Oct 21 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.3.2-2
- Upgrade to 1.3.2 sources, previously using 1_3_20060920

* Wed Aug 19 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.3.2-1.3
- Add pom.xml file to repolib
 
* Wed Aug 19 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.3.2-1.2
- Change component-info.xml 

* Thu Jul 30 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.3.2-1.1
- Change repolib artifact id from sun-saaj-1.3-impl to saaj-impl

* Thu Jul 30 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.3.2-1
- Upgrade to 1.3.2
- Add repolib

* Thu Jul 09 2009 Yong Yang <yyang@redhat.com> - 0:1.3.1-3
- Change "BuildRequires:  jpackage-utils >= 0:1.7.4" to "BuildRequires:  jpackage-utils >= 0:1.7.3"
- build-classpath by using sun-saaj-1.3-api instead of saaj_1_3_api

* Tue Apr 21 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.3.1-2.jpp5
- First JPP-5 release

* Fri Mar 28 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.3.1-1jpp
- First release

